//redFrik 2009
//released under gnu gpl license

KretsloppKontroll {
	var	<port,
		<>action, <>s0action, <>s1action, <>s2action, <cvs,
		thread, win,
		s0last, s0lastTime, s1last, s1lastTime, s2last, s2lastTime;
	*new {|portName, action|
		^super.new.initKretsloppKontroll(portName, action)
	}
	initKretsloppKontroll {|portName, argAction|
		if(portName.isNil, {
			portName= SerialPort.devices.detect{|x| x.contains("tty.usbserial-")};
		});
		action= argAction;
		if(SerialPort.devices.any{|x| x==portName}, {
			port= SerialPort(portName, 38400, crtscts: true);
			(this.class.name++": connected to"+portName).inform;
			thread= Routine({this.prRead});
		}, {
			(this.class.name++": port"+portName+"not found").warn;
		});
		cvs= (
			\mix: CV.new.spec_(ControlSpec(0, 1, \lin, 0, 0)),
			\fre: CV.new.spec_(ControlSpec(0, 1, \lin, 0, 0)),
			\alt: CV.new.spec_(ControlSpec(0, 1, \lin, 0, 0)),
			\a0: CV.new.spec_(ControlSpec(0, 1, \lin, 0, 0)),
			\a1: CV.new.spec_(ControlSpec(0, 1, \lin, 0, 0)),
			\a2: CV.new.spec_(ControlSpec(0, 1, \lin, 0, 0)),
			\s0: CV.new.spec_(ControlSpec(0, 1, \lin, 1, 0)),
			\s1: CV.new.spec_(ControlSpec(0, 1, \lin, 1, 0)),
			\s2: CV.new.spec_(ControlSpec(0, 1, \lin, 1, 0))
		);
		cvs.do{|x| x.action= {this.prAction}};
		s0lastTime= SystemClock.seconds;
		s1lastTime= SystemClock.seconds;
		s2lastTime= SystemClock.seconds;
		CmdPeriod.doOnce({this.close});
		thread.play;
	}
	close {
		thread.stop;
		if(port.notNil, {port.close});
		if(win.notNil and:{win.isClosed.not}, {
			win.close;
		});
	}
	makeWindow {|position|
		var	w= 100, h= 30,
			knobCols= [Color.grey(0.8, 0.8), Color.black, Color.grey(0.8, 0.8), Color.black];
		position= position ?? {Point(830, 200)};
		win= Window(this.class.name, Rect(position.x, position.y, w+40, (h*2+4*3)+(h+4*6)), false);
		win.view.background= Color.grey(0.7);
		win.view.decorator= FlowLayout(win.view.bounds);
		
		cvs.mix.connect(Knob(win, Rect(0, 0, h*2, h*2)).color_(knobCols));
		StaticText(win, Rect(0, 0, 20, h)).string_("mix");
		win.view.decorator.nextLine;
		cvs.fre.connect(Knob(win, Rect(0, 0, h*2, h*2)).color_(knobCols));
		StaticText(win, Rect(0, 0, 20, h)).string_("fre");
		win.view.decorator.nextLine;
		cvs.alt.connect(Knob(win, Rect(0, 0, h*2, h*2)).color_(knobCols));
		StaticText(win, Rect(0, 0, 20, h)).string_("alt");
		win.view.decorator.nextLine;
		cvs.a0.connect(Slider(win, Rect(0, 0, w, h)).knobColor_(Color.black));
		StaticText(win, Rect(0, 0, 20, h)).string_("a0");
		win.view.decorator.nextLine;
		cvs.a1.connect(Slider(win, Rect(0, 0, w, h)).knobColor_(Color.black));
		StaticText(win, Rect(0, 0, 20, h)).string_("a1");
		win.view.decorator.nextLine;
		cvs.a2.connect(Slider(win, Rect(0, 0, w, h)).knobColor_(Color.black));
		StaticText(win, Rect(0, 0, 20, h)).string_("a2");
		win.view.decorator.nextLine;
		cvs.s0.connect(
			Button(win, Rect(0, 0, w, h))
				.states_([
					["-", Color.black, Color.grey(0.6)],
					["-", Color.grey(0.6), Color.black]
				])
		);
		win.view.decorator.nextLine;
		cvs.s1.connect(
			Button(win, Rect(0, 0, w, h))
				.states_([
					["+", Color.black, Color.grey(0.6)],
					["+", Color.grey(0.6), Color.black]
				])
		);
		win.view.decorator.nextLine;
		cvs.s2.connect(
			Button(win, Rect(0, 0, w, h))
				.states_([
					["set", Color.black, Color.grey(0.6)],
					["set", Color.grey(0.6), Color.black]
				])
		);
		win.front;
	}
	
	//--private
	prRead {
		//protocol: fe, fe, fe, k0, k1, k2, a0, a1, a2, sw, ff
		var	byte, i= 0, arr= [0, 0, 0, 0, 0, 0, 0];
		loop{
			byte= port.read;
			case
				{i>=3 and:{i<10}} {
					arr= arr.put(i-3, byte);
					i= i+1;
				}
				{i==0 and:{byte==0xfe}} {
					i= 1;
				}
				{i==1 and:{byte==0xfe}} {
					i= 2;
				}
				{i==2 and:{byte==0xfe}} {
					i= 3;
				}
				{i==10 and:{byte==0xff}} {
					if(arr[6]|56!=56, {
						(this.class.name++": serial read error2"+byte+i+arr).error;
						i= 0;
					}, {
						cvs.alt.value= arr[0]/255;
						cvs.fre.value= arr[1]/255;
						cvs.mix.value= arr[2]/255;
						cvs.a0.value= arr[3]/255;
						cvs.a1.value= arr[4]/255;
						cvs.a2.value= arr[5]/255;
						cvs.s0.value= (arr[6]&8!=8).binaryValue;
						cvs.s1.value= (arr[6]&16!=16).binaryValue;
						cvs.s2.value= (arr[6]&32!=32).binaryValue;
						arr= [0, 0, 0, 0, 0, 0, 0];
						i= 0;
						this.prAction;
					});
				}
				{
					(this.class.name++": serial read error"+byte+i+arr).error;
					i= 0;
				}
			;
		}
	}
	prAction {
		action.value(cvs);
		if(cvs.s0.value!=s0last, {
			if(s0last.notNil, {
				s0action.value(cvs.s0.value, SystemClock.seconds-s0lastTime);
			});
			s0lastTime= SystemClock.seconds;
			s0last= cvs.s0.value;
		});
		if(cvs.s1.value!=s1last, {
			if(s1last.notNil, {
				s1action.value(cvs.s1.value, SystemClock.seconds-s1lastTime);
			});
			s1lastTime= SystemClock.seconds;
			s1last= cvs.s1.value;
		});
		if(cvs.s2.value!=s2last, {
			if(s2last.notNil, {
				s2action.value(cvs.s2.value, SystemClock.seconds-s2lastTime);
			});
			s2lastTime= SystemClock.seconds;
			s2last= cvs.s2.value;
		});
	}
}
